Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mozilla.javascript.ast
Class SwitchStatement

    java.lang.Object
      org.mozilla.javascript.Node
          org.mozilla.javascript.ast.AstNode
              org.mozilla.javascript.ast.Jump
                  org.mozilla.javascript.ast.SwitchStatement

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class SwitchStatement

extends Jump

Switch statement AST node type. Node type is `Token.SWITCH`.

    SwitchStatement :
            switch ( Expression ) CaseBlock
     CaseBlock :
            { [CaseClauses] }
            { [CaseClauses] DefaultClause [CaseClauses] }
     CaseClauses :
            CaseClause
            CaseClauses CaseClause
     CaseClause :
            case Expression : [StatementList]
     DefaultClause :
            default : [StatementList]

Nested Class Summary

Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode
`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

Nested classes/interfaces inherited from class org.mozilla.javascript.Node
`Node.NodeIterator`

Field Summary

Fields inherited from class org.mozilla.javascript.ast.Jump
`target`

Fields inherited from class org.mozilla.javascript.ast.AstNode
`length, parent, position`

Fields inherited from class org.mozilla.javascript.Node
`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

Constructor Summary
`SwitchStatement()`
`SwitchStatement(int pos)`
`SwitchStatement(int pos, int len)`

Method Summary
`void` | `addCase(SwitchCase switchCase)` Adds a switch case statement to the end of the list.
`java.util.List<SwitchCase>` | `getCases()` Returns case statement list.
`AstNode` | `getExpression()` Returns the switch discriminant expression
`int` | `getLp()` Returns left paren position, -1 if missing
`int` | `getRp()` Returns right paren position, -1 if missing
`void` | `setCases(java.util.List<SwitchCase> cases)` Sets case statement list, and sets the parent of each child case to this node.
`void` | `setExpression(AstNode expression)` Sets the switch discriminant expression, and sets its parent to this node.
`void` | `setLp(int lp)` Sets left paren position
`void` | `setParens(int lp, int rp)` Sets both paren positions
`void` | `setRp(int rp)` Sets right paren position
`java.lang.String` | `toSource(int depth)` Emits source code for this node.
`void` | `visit(NodeVisitor v)` Visits this node, then the switch-expression, then the cases in lexical order.

Methods inherited from class org.mozilla.javascript.ast.Jump
`getContinue, getDefault, getFinally, getJumpStatement, getLoop, setContinue, setDefault, setFinally, setJumpStatement, setLoop`

Methods inherited from class org.mozilla.javascript.ast.AstNode
`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

Methods inherited from class org.mozilla.javascript.Node
`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, setDouble, setJsDoc, setLineno, setScope, setString, setType, toString, toStringTree`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SwitchStatement

    public SwitchStatement()

### SwitchStatement

    public SwitchStatement(int pos)

### SwitchStatement

    public SwitchStatement(int pos,
                           int len)

Method Detail

### getExpression

    public AstNode getExpression()

  Returns the switch discriminant expression

### setExpression

    public void setExpression(AstNode expression)

  Sets the switch discriminant expression, and sets its parent to this node.

  Throws:
    `IllegalArgumentException}` - if expression is `null`

### getCases

    public java.util.List<SwitchCase> getCases()

  Returns case statement list. If there are no cases, returns an immutable empty list.

### setCases

    public void setCases(java.util.List<SwitchCase> cases)

  Sets case statement list, and sets the parent of each child case to this node.

  Parameters:
    `cases` - list, which may be `null` to remove all the cases

### addCase

    public void addCase(SwitchCase switchCase)

  Adds a switch case statement to the end of the list.

  Throws:
    `IllegalArgumentException}` - if switchCase is `null`

### getLp

    public int getLp()

  Returns left paren position, -1 if missing

### setLp

    public void setLp(int lp)

  Sets left paren position

### getRp

    public int getRp()

  Returns right paren position, -1 if missing

### setRp

    public void setRp(int rp)

  Sets right paren position

### setParens

    public void setParens(int lp,
                          int rp)

  Sets both paren positions

### toSource

    public java.lang.String toSource(int depth)

  Description copied from class: `AstNode`
  Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

  Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

  Overrides:
    `toSource` in class `Jump`
  Parameters:
    `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

### visit

    public void visit(NodeVisitor v)

  Visits this node, then the switch-expression, then the cases in lexical order.

  Overrides:
    `visit` in class `Jump`
  Parameters:
    `v` - the object to call with this node and its children

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD